var strSPFSURL;
if (!bIsDevice())		//site in browser, not a phone
{
	strSPFSURL = '/app_vertical_recipe.asp';
}
else
{
	strSPFSURL = 'https://recipes.sparkpeople.com/app_vertical_recipe.asp';
}

var strRECIPEINFOURL;
if (!bIsDevice())		//site in browser, not a phone
{
	strRECIPEINFOURL = '/iphone_details.asp';
}
else
{
	strRECIPEINFOURL = 'https://recipes.sparkpeople.com/iphone_details.asp';
}

var strRECIPERATINGSURL;
if (!bIsDevice())		//site in browser, not a phone
{
	strRECIPERATINGSURL = '/recipe-ratings-vertical.asp';
}
else
{
	strRECIPERATINGSURL = 'https://recipes.sparkpeople.com/recipe-ratings-vertical.asp';
}


var constRECIPE_VERTICAL_APP = 7;

var constGETHOMECATEGORY = 1;
var constGETCATEGORY = 2;
var constGETRATINGS = 3;
var constGETFAVORITES = 4;

var constBREAKFAST = 0;
var constLUNCH = 1;
var constDINNER = 2;
var constSIDES = 3;
var constDESSERTS = 4;

var iNumCategories = 5;

var iCurrentRecipeNum = 0;
var strCurrentRecipeImage = "";
var strCurrentRecipeTitle = "";
var strCurrentRecipeIntro = "";

var aiCategories = [];

function getCategoryName(iCategory)
{
	var strReturn;
	switch (iCategory)
	{
		 case constBREAKFAST: strReturn = "Nourishing Breakfasts"; break;
		 case constLUNCH: strReturn = "Low-Carb Lunches"; break;
		 case constDINNER: strReturn = "Diabetes-Friendly Dinners"; break;
		 case constSIDES: strReturn = "Simple Appetizers & Sides"; break;
		 case constDESSERTS: strReturn = "Low-Sugar Desserts"; break;
	}
	return strReturn;

}


function onPageLoad()
{
    consoleLog("Installed console !");	
	consoleLog('Loaded Index.js');	
	ga_storage._setAccount('UA-50975602-14');
	if(bIsDevice()) 
	{
		PinterestPlugin.init("1437124", function() { consoleLog('Pinterest init'); }, function () {consoleLog('Pinterest FAILED init'); } );
	}
    trackPageView('/index.html','AppStartup - ' + getPlatform());
	if (navigator.notification) 
	{ // Override default HTML alert with native dialog
		window.alert = function (message) 
		{
			navigator.notification.alert(
				message,    // message
				null,       // callback
				strAppName, // title
				strOKMessage        // buttonName
			);
		};
	}
	document.addEventListener("backbutton", onBackKeyDown, false);
	$("#recipe_tabs").tabs({
		activate: function (event, ui) {
			refreshAds();
			var active = $('#recipe_tabs').tabs('option', 'active');
			trackPageView($("#recipe_tabs ul>li a").eq(active).attr("href"), "id=" + iCurrentRecipeNum + " - " + getPlatform());
			}
		}
	);
	fillHome();
}

function gotoFavorites()
{
	var storage = window.localStorage;
	var bSaved = false;
	if(storage)
	{

		var strSavedRecipes;
		strSavedRecipes = storage.getItem("recipes");
		$.ajax({
			url : strSPFSURL + '?t=' + constGETFAVORITES + '&app=' + constRECIPE_VERTICAL_APP,
			type : "post",
			data: { list: strSavedRecipes },
			success : function(data, textStatus, jqXHR) {
				fillFavoritesDiv(data);
				function fillFavoritesDiv(objReturn)
				{
					var strImage;
					var strTitle;
					var strTeaser;
					var iID;
					$("#category_content").html('');
					if (objReturn.length < 1)
					{
						$("#category_content").html('<H2>No favorites saved</H2>');

					}
					else
					{
						$("#category_content").html('<h1>My Favorites</h1>');
					}
					for (var i = 0; i < objReturn.length; i++)
					{
						strImage = objReturn[i].image;
						strTitle = objReturn[i].title;
						strTeaser = objReturn[i].teaser;
						iID = objReturn[i].id;
						if (strImage != "")
						{
							$("#category_content").append('<div class="recipe_image_home_container"><a href="#" onClick="return gotoRecipe(' + iID + ');"><img src="' + strImage + '" border="0" class="recipe_image_home"></a></div><div class="recipe_title_home"><a href="#" onClick="return gotoRecipe(' + iID + ');">' + strTitle + '</a></div><div class="recipe_teaser_home">' + strTeaser + "</div>");
						}
						else
						{
							$("#category_content").append('<div class="recipe_title_home"><a href="#" onClick="return gotoRecipe(' + iID + ');">' + strTitle + '</a></div><div class="recipe_teaser_home">' + strTeaser + "</div>");
						}
					}
				}
			}
		});
		$("#category_content").loader({ text: "Loading..." });
		trackPageView("Favorites Page", getPlatform());
		gotoContentSection("#category", { transition: "pop", allowSamePageTransition: true });
	}
}

function gotoOtherApps()
{
	trackPageView("Other Apps",getPlatform());
	window.open('http://www.sparkpeople.com/mobile-apps.asp', '_system');
}

function gotoCategory(iCategory)
{
	$.ajax({
		url : strSPFSURL + '?t=' + constGETCATEGORY + '&app=' + constRECIPE_VERTICAL_APP + '&cat=' + iCategory,
		type : "get",
		iCatValue : iCategory,
		success : function(data, textStatus, jqXHR) {
			fillHomeCategoryDiv(data,this.iCatValue);
			function fillHomeCategoryDiv(objReturn, iCat)
			{
				var strImage;
				var strTitle;
				var strTeaser;
				var iID;
				$("#category_content").html('<h1>' + getCategoryName(iCat) + '</h1>');
				for (var i = 0; i < objReturn.length; i++)
				{
					strImage = objReturn[i].image;
					strTitle = objReturn[i].title;
					strTeaser = objReturn[i].teaser;
					iID = objReturn[i].id;
					if (strImage != "")
					{
						$("#category_content").append('<div class="recipe_image_home_container"><a href="#" onClick="return gotoRecipe(' + iID + ');"><img src="' + strImage + '" border="0" class="recipe_image_home"></a></div><div class="recipe_title_home"><a href="#" onClick="return gotoRecipe(' + iID + ');">' + strTitle + '</a></div><div class="recipe_teaser_home">' + strTeaser + "</div>");
					}
					else
					{
						$("#category_content").append('<div class="recipe_title_home"><a href="#" onClick="return gotoRecipe(' + iID + ');">' + strTitle + '</a></div><div class="recipe_teaser_home">' + strTeaser + "</div>");
					}
				}
			}
		}
	});
	$("#category_content").loader({ text: "Loading..." });
	trackPageView("Category Page", getCategoryName(iCategory) + ' - ' + getPlatform());
	gotoContentSection("#category", { transition: "pop", allowSamePageTransition: true });
}

function gotoHome()
{
	trackPageView("Home Page", getPlatform());
	gotoContentSection("#home", { transition: "pop", allowSamePageTransition: true });
}

function fillHome()
{
	randomizeCategories();
	for (var i = 0; i < iNumCategories; i++)
	{
		$("#home_content").append("<div class='category_home'><h1>" + getCategoryName(aiCategories[i]) + "</h1><div id='category_home_items_" + aiCategories[i] + "'><div class='loading_content'></div></div><button onclick='return gotoCategory(" + aiCategories[i] + ");' data-theme='b'>More " + getCategoryName(aiCategories[i]) + "</button></div>");
		$.ajax({
			url : strSPFSURL + '?t=' + constGETHOMECATEGORY + '&app=' + constRECIPE_VERTICAL_APP + '&cat=' + aiCategories[i],
			type : "get",
			iCatValue : aiCategories[i],
			success : function(data, textStatus, jqXHR) {
				fillHomeCategoryDiv(data,this.iCatValue);
				function fillHomeCategoryDiv(objReturn, iCat)
				{
					var strImage;
					var strTitle;
					var strTeaser;
					var iID;
					$("#category_home_items_" + iCat).html('');
					for (var i = 0; i < objReturn.length; i++)
					{
						strImage = objReturn[i].image;
						strTitle = objReturn[i].title;
						strTeaser = objReturn[i].teaser;
						iID = objReturn[i].id;
						$("#category_home_items_" + iCat).append('<div class="recipe_image_home_container"><a href="#" onClick="return gotoRecipe(' + iID + ');"><img src="' + strImage + '" border="0" class="recipe_image_home"></a></div><div class="recipe_title_home"><a href="#" onClick="return gotoRecipe(' + iID + ');">' + strTitle + '</a></div><div class="recipe_teaser_home">' + strTeaser + "</div>");
					}
				}
			}
		});

	}
	$("#home_content").trigger("create");
	$("#category_home_items_" + aiCategories[1]).loader({ text: "Loading..." });
}

function fillStars(dStars)
{
	for (var i = 1; i <= 5 ; i++)
	{
		$("#star" + i).attr("src","img/star_blank.gif");
	}

	if (dStars >= 1.0)
	{
		$("#star1").attr("src","img/star.gif");
	}
	if (dStars >= 1.5)
	{
		$("#star2").attr("src","img/star_half.gif");
	}
	if (dStars >= 2.0)
	{
		$("#star2").attr("src","img/star.gif");
	}
	if (dStars >= 2.5)
	{
		$("#star3").attr("src","img/star_half.gif");
	}
	if (dStars >= 3.0)
	{
		$("#star3").attr("src","img/star.gif");
	}
	if (dStars >= 3.5)
	{
		$("#star4").attr("src","img/star_half.gif");
	}
	if (dStars >= 4.0)
	{
		$("#star4").attr("src","img/star.gif");
	}
	if (dStars >= 4.5)
	{
		$("#star5").attr("src","img/star_half.gif");
	}
	if (dStars >= 5.0)
	{
		$("#star5").attr("src","img/star.gif");
	}

}
/*
'	0.recipe name || 1.recipe intro || 2.number of ratings || 3.text list of ingredients ||
'	4.recipe text || 5.calories || 6.fat || 7.cholesterol || 8.sodium || 9.carbs ||
'	10.fiber || 11.protein || 12.sugar || 13.poly fat || 14.mono fat || 15.sat fat || 16.potassium ||
'	17.recipe id || 18.serving size || 19.serving_ind || 20.total time || 21.ad category || 22.imagePath || 23.imageWidth || 24.imageHeight
'	}}}}} stars
*/
function fillRecipeAndGo(objReturn, iRecipe)
{
	var dStars = 0.0;
	if(objReturn.indexOf('}}}}}') >= 0)
	{
		var aTemp = objReturn.split('}}}}}');
		objReturn = aTemp[0];
		dStars = parseFloat(aTemp[1]);
	}
	fillStars(dStars);
	var aItems = objReturn.split("||");
	strCurrentRecipeTitle = '';
	strCurrentRecipeIntro = '';
	var iNumRatings = 0;
	var strIngredients = '';
	var strRecipeDirections = '';
	var dCalories = 0;
	var dFat = 0;
	var dCholesterol = 0;
	var dSodium = 0;
	var dCarbs = 0;
	var dFiber = 0;
	var dProtein = 0;
	var dSugar = 0;
	var dPoly = 0;
	var dMono = 0;
	var dSatFat = 0;
	var dPotassium = 0;
	var strServingSize = '';
	var strServingInd = '';
	var strTotalTime = '';
	strCurrentRecipeImage = 'http://recipes.sparkpeople.com/spacer.gif';
	if (aItems[0]) strCurrentRecipeTitle = aItems[0];
	if (aItems[1]) strCurrentRecipeIntro = aItems[1];
	if (aItems[2]) iNumRatings = aItems[2];
	if (aItems[3]) strIngredients = aItems[3];
	if (aItems[4]) strRecipeDirections = aItems[4];
	if (aItems[5]) dCalories = aItems[5];
	if (aItems[6]) dFat = aItems[6];
	if (aItems[7]) dCholesterol = aItems[7];
	if (aItems[8]) dSodium = aItems[8];
	if (aItems[9]) dCarbs = aItems[9];
	if (aItems[10]) dFiber = aItems[10];
	if (aItems[11]) dProtein = aItems[11];
	if (aItems[12]) dSugar = aItems[12];
	if (aItems[13]) dPoly = aItems[13];
	if (aItems[14]) dMono = aItems[14];
	if (aItems[15]) dSatFat = aItems[15];
	if (aItems[16]) dPotassium = aItems[16];
	if (aItems[19]) strServingInd = aItems[19];
	if (aItems[18]) strServingSize = aItems[18];
	if (aItems[20]) strTotalTime = aItems[20];
	if (aItems[22]) strCurrentRecipeImage = aItems[22];
	$("#recipe_title").html(strCurrentRecipeTitle);
	$("#recipe_intro").html(strCurrentRecipeIntro);
	$("#ratings_number").html(iNumRatings);
	strIngredients = "<ul><li>" + strIngredients + "</li></ul>";
	strIngredients = strIngredients.replace(/[\n\r]/g, "</li><li>");
	strIngredients = strIngredients.replace(/<li><\/li>/gi, "");
	$("#recipe_ingredients").html(strIngredients);
	$("#recipe_directions").html(strRecipeDirections);
	$("#nut_calories").html(dCalories);
	$("#nut_fat").html(dFat);
	$("#nut_cholesterol").html(dCholesterol);
	$("#nut_sodium").html(dSodium);
	$("#nut_carbs").html(dCarbs);
	$("#nut_fiber").html(dFiber);
	$("#nut_protein").html(dProtein);
	$("#nut_sugar").html(dSugar);
	$("#nut_poly_fat").html(dPoly);
	$("#nut_mono_fat").html(dMono);
	$("#nut_sat_fat").html(dSatFat);
	$("#nut_potassium").html(dPotassium);
	$("#recipe_serving_size").html(strServingSize);
	$("#recipe_number_servings").html(strServingInd);
	$("#ind_recipe_img").attr("src",strCurrentRecipeImage);
	
	$("#recipe_tabs" ).tabs({ active: 0 });
	$("#recipe_directions_tab").addClass('ui-btn-active');
	gotoContentSection("#recipe", { transition: "pop", allowSamePageTransition: true });
}

function fillRecipeRatings(objReturn, iRecipe)
{
	$("#ratings").html(objReturn);
}

function gotoRecipe(iID)
{
	iCurrentRecipeNum = iID;
	$.ajax({
		url : strRECIPEINFOURL + '?showadcode=1&recipe=' + iCurrentRecipeNum + '&did=' + getPlatform() + '&src=' + getPlatform() + '&app_name=recipe_vertical&ver=1&app=' + constRECIPE_VERTICAL_APP,
		type : "get",
		iRecipe : iID,
		success : function(data, textStatus, jqXHR) {
			fillRecipeAndGo(data,this.iRecipe);
		}
	});
	$("#ratings").html("<div class='loading_content'></div>");
	$.ajax({
		url : strSPFSURL + '?t=' + constGETRATINGS + '&recipe=' + iCurrentRecipeNum + '&did=' + getPlatform() + '&src=' + getPlatform() + '&app_name=recipe_vertical&app=' + constRECIPE_VERTICAL_APP + '&ver=1',
		type : "get",
		iRecipe : iID,
		success : function(data, textStatus, jqXHR) {
			fillRecipeRatings(data,this.iRecipe);
		}
	});
	updateSaveButtonUnknown();
	refreshAds();
}

function isRecipeSaved(iRecipe)
{
	var storage = window.localStorage;
	var bSaved = false;
	if(storage)
	{
		var strRecipe = "<" + iRecipe + ">";

		var strSavedRecipes;
		strSavedRecipes = storage.getItem("recipes");
		if (!strSavedRecipes)
		{
			return false;
		}
		if (strSavedRecipes.indexOf(strRecipe) < 0)
		{
			bSaved = false;
		}
		else
		{
			bSaved = true;
		}
	}
	return bSaved;
}

function updateSaveButtonUnknown()
{
	var bSaved = isRecipeSaved(iCurrentRecipeNum);
	updateSaveButton(bSaved);
}

function updateSaveButton(bSaved)
{
	if (bSaved)
	{
		$("#save_img").attr("src", "img/saved.png");
		$("#save_img_bot").attr("src", "img/saved.png");
	}
	else
	{
		$("#save_img").attr("src", "img/save.png");
		$("#save_img_bot").attr("src", "img/save.png");
	}
}

function saveUnSaveRecipe()
{
	var storage = window.localStorage;
	var bSaved = false;
	if(storage)
	{
		var strRecipe = "<" + iCurrentRecipeNum + ">";

		var strSavedRecipes;
		strSavedRecipes = storage.getItem("recipes");
		if (!strSavedRecipes)
		{
			strSavedRecipes = "";
		}
		if(strSavedRecipes.indexOf(strRecipe) >= 0)
		{
			while(strSavedRecipes.indexOf(strRecipe) >= 0) strSavedRecipes = strSavedRecipes.replace(strRecipe, '');
			bSaved = false;
		}
		else
		{
			strSavedRecipes += strRecipe;
			bSaved = true;
		}
		storage.setItem("recipes", strSavedRecipes);
		updateSaveButton(bSaved);

	}
	else
	{
		consoleLog("no localstorage");
	}
}

function randomizeCategories()
{
	for(var i = 0; i < iNumCategories; i++)
	{
		aiCategories.push(i);
	}
	for(var i = iNumCategories - 1; i >= 0; i--)
	{
		var iSwap = Math.floor(random() * (iNumCategories - 1));
		var iTmp = aiCategories[iSwap];
		aiCategories[iSwap] = aiCategories[i];
		aiCategories[i] = iTmp;
	}
	

}


function onBackKeyDown()
{
	switch($.mobile.activePage.attr('id'))
	{
		case 'recipe':
			window.history.back();
			break;
		case 'category':
			gotoHome();
			break;
		case 'home':
			if(navigator.app)
				navigator.app.exitApp();
			break;
		default:
			window.history.back();
			break;
	}
}

function shareFacebook()
{
	trackPageView("Facebook Share",'id=' + iCurrentRecipeNum + ' - ' + getPlatform());
	if(isWP())
	{
		window.open('http://www.facebook.com/sharer/sharer.php?u=http://recipes.sparkpeople.com/recipe-detail.asp?recipe=' + iCurrentRecipeNum, '_system');
	}
	else
	{
		window.plugins.socialsharing.shareViaFacebook(
			'',
			null /*image*/, 
			'http://recipes.sparkpeople.com/recipe-detail.asp?recipe=' + iCurrentRecipeNum, 
			function() {
				consoleLog('share ok')
			},
			function(errormsg){
					window.open('http://www.facebook.com/sharer/sharer.php?u=http://recipes.sparkpeople.com/recipe-detail.asp?recipe=' + iCurrentRecipeNum, '_system');
			}
		);
	}
}

function sharePinterest()
{
	trackPageView("Pinterest Share",'id=' + iCurrentRecipeNum + ' - ' + getPlatform());
	if(isWP())
	{
		window.open("http://www.pinterest.com/pin/create/button/?url=http%3A%2F%2Frecipes%2Esparkpeople%2Ecom%2Frecipe%2Ddetail%2Easp%3Frecipe%3D" + iCurrentRecipeNum + "&media=" + strCurrentRecipeImage + "&description=" + escape(strCurrentRecipeIntro), "_system");
	}
	else
	{
		PinterestPlugin.pin(
			'http://recipes.sparkpeople.com/recipe-detail.asp?recipe=' + iCurrentRecipeNum, 
			strCurrentRecipeImage, 
			strCurrentRecipeIntro, 
			function() {
				consoleLog('Pinterest Share Success');
			}, 
			function() {
				window.open("http://www.pinterest.com/pin/create/button/?url=http%3A%2F%2Frecipes%2Esparkpeople%2Ecom%2Frecipe%2Ddetail%2Easp%3Frecipe%3D" + iCurrentRecipeNum + "&media=" + strCurrentRecipeImage + "&description=" + escape(strCurrentRecipeIntro), "_system");
			}
		);
	}

}

function shareEmail()
{
	trackPageView("Email Share",'id=' + iCurrentRecipeNum + ' - ' + getPlatform());
	window.open("mailto:?subject=Sharing from SparkRecipes.com - " + strCurrentRecipeTitle + "&body=I wanted to share this page from SparkRecipes.com: %0A%0Ahttp://recipes.sparkpeople.com/recipe-detail.asp?recipe=" + iCurrentRecipeNum + " from SparkRecipes.com.", "_system");

}

function trackPageView(strPage, strTitle)
{
	consoleLog("pageview = " + strPage);
	ga_storage._trackPageview(strPage, strTitle);
}

var ord = Number(ord) || Math.floor(Math.random()*10e12);
var strAdURL = "";

function refreshAds()
{
	return;		//giving up on this for now
	ord = Math.floor(Math.random()*10e12);
	$.ajax({
		url : "https://pubads.g.doubleclick.net/gampad/adx?iu=6635/spmobile.app/quick_and_easy_recipe&sz=320x50&c=" + ord,
		type : "get",
		success : function(data, textStatus, jqXHR) {
			var doc = document.createElement("div");
			doc.innerHTML = data;
			//links
			var strURLs = [];
			var strImgs = [];
			var strNoScript = doc.getElementsByTagName("noscript");
			for(var i = 0; i < strNoScript.length; i++)
			{
				var doc2 = document.createElement("div");
				doc2.innerHTML = strNoScript[i].innerText;
				var strATags = doc2.getElementsByTagName("a");
				for (var j = 0; j < strATags.length; j++)
				{
					strURLs.push(strATags[j].getAttribute("href"));
				}
				var strATags = doc2.getElementsByTagName("img");
				for (var j = 0; j < strATags.length; j++)
				{
					strImgs.push(strATags[j].getAttribute("src"));
				}
			}
			if (strURLs.length > 0 && strImgs.length > 0)
			{
				strAdURL = strURLs[0];
				$("#ad_img").attr("src",strImgs[0]);

			}
 		}
	});
}


function adClick()
{
	window.open(strAdURL, '_system');

}